Subject: bug#69271: 30.0.50; Strange interaction between :inverse-video overlay face and calendar today face

From: Eli Zaretskii <[email-masked]>
Date: Tue, 20 Feb 2024 18:08:14 +0200

> From: Ihor Radchenko <[email-masked]>
> Date: Mon, 19 Feb 2024 12:14:28 +0000
> 
> 1. emacs -Q
> 2. Insert the following code into *scratch* buffer
> 
> 
> (defface yant/test '((t :foreground "red" :weight bold)) "")
> (defface yant/test-inv '((t :foreground "red"  :inverse-video t)) "")
> (require 'calendar)
> 
> ;; (dotimes (_ 5)
> ;;   (let* ((mark-calendar
> ;; 	  (lambda ()
> ;; 	    (calendar-mark-visible-date
> ;; 	     (read (format-time-string "(%m %d %Y)"))
> ;; 	     'yant/test)))
> ;; 	 (calendar-today-visible-hook))
> ;;     (add-hook 'calendar-today-visible-hook mark-calendar)
> ;;     (calendar)
> ;;     (setq cursor-type nil)
> ;;     (let ((ov (make-overlay (1- (point)) (1+ (point)))))
> ;;       (overlay-put ov 'face 'yant/test-inv)))
> ;;   (read-char "Observe overlay obeying inverse-video. Press any key")
> ;;   (kill-buffer calendar-buffer))
> (dotimes (_ 50)
>   (let* ((mark-calendar
> 	  (lambda ()
> 	    (calendar-mark-visible-date
> 	     (read (format-time-string "(%m %d %Y)"))
> 	     (list :foreground "red" :weight 'bold))))
> 	 (calendar-today-visible-hook))
>     (add-hook 'calendar-today-visible-hook mark-calendar)
>     (calendar)
>     (setq cursor-type nil)
>     (let ((ov (make-overlay (1- (point)) (1+ (point)))))
>       (overlay-put ov 'face 'yant/test-inv)))
>   (read-char "Observe overlay sometimes *not* obeying inverse-video. Press any key")
>   (kill-buffer calendar-buffer))
> 
> 3. M-x eval-buffer <RET>
> 4. Observe today date in the calendar fontified inconsistently as the
>    code is executed multiple times.

This code places two overlays on the same text, with each overlay
defining a foreground color.  So which one "wins" is basically random,
unless you give each overlay a priority to make that deterministic.

I tried a simpler recipe:

  emacs -Q
  M-x load-library RET calendar RET
  C-x b foo RET
  C-u 30 a RET
  M-: (defface yant/test-inv '((t :foreground "red"  :inverse-video t)) "") RET
  M-: (setq ov1 (make-overlay 24 26)) RET
  M-: (overlay-put ov1 'face (calendar-make-temp-face (list :foreground "red" :weight 'bold))) RET
  M-: (setq ov2 (make-overlay 24 26)) RET
  M-: (overlay-put ov2 'face 'yant/test-inv) RET

This produced text with red background, according to the yant/test-inv
face.  But if you define the overlays in the opposite order, you get
the red bold foreground instead.  If you now give each overlay a
priority, you can control which face shows: the one whose overlay has
the higher priority.

Maybe I'm missing something, but I see no bug here.